﻿using System;

namespace Demo7
{
    /// @author  Vesa Lappalainen, Antti-Jussi Lakanen
    /// @version 2025
    /// <summary>
    /// Summataan matriisit. Tässä pääohjelmassa lähinnä testataan 
    /// taulukkoaliohjelmia (ks. Taulukot.cs).
    /// Tässä käytetään myös aikaisempaa Matriisit.cs-tiedostoa.
    /// </summary>
    public class TaulukotPaa
    {
        /// <summary>
        /// Testataan taulukkoaliohjelmia.
        /// </summary>
        /// <param name="args">ei käytössä</param>
        public static void Main(string[] args)
        {
            Taulukot.ErotaDouble("k", 1);
            double[,] mat1 = { { 1, 2, 3 }, { 2, 2, 2 }, { 4, 2, 3 } };
            double[,] mat2 = { { 9, 2, 8 }, { 1, 2, 5 }, { 3, 19, -3 } };
            double[,] mat3 = Taulukot.Summa(mat1, mat2);
            Console.WriteLine(Matriisit.Jonoksi(mat3, " ", "{0, 5:0.00}"));

            double[] luvut = Taulukot.ErotaLuvut("2.23 3 4 5 k      9 ;5");
            Console.WriteLine(Matriisit.Jonoksi(luvut, " ", "{0, 5:0.00}"));
        }
    }
}
