using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Tehtävä 3 malliratkaisu. Tätä koodia käytetään Timissä automaattiseen arviointiin. 
/// </summary>
public class T3_SanojenPituus
{
    public static void Main()
    {
        // SanojenPituusKeskiarvo("Kolme miestä istuu saunassa.");

        //DELETEBEGIN
        string[] lauseet = {"Oudoksuttavaa kyllä, on useasti todettu, että asynkroninen asiakaskokemus auttaa käyttäjää ymmärtämään järjestelmän ulkopuolelle jääneitä epäonnistuneita prosesseja.",
        "Jotta emme unohtaisi yhteisön pyrkimyksiä, todettakoon, että vallankumouksellinen kolmannen sukupolven matkapuhelimien ja varsinkin e-business -sektorille suunnattujen laitteiden kirjo ennakoi osaltaan vastuunalaisia kontradiktioita.",
        "Eräitä yksityiskohtia lukuunottamatta tietoyhteiskunta näyttelee keskeistä osaa pohdittaessa huonoja taloudellisia ja hallinnollisia oloja.",
        "Ei sovi unohtaa, että asynkroninen asiakaskokemus näyttää todeksi asianosaisiin kohdistuvia ongelmia.",
        "Vaikka osaltamme onkin saatettu syyllistyä laiminlyönteihin, voidaan taholtamme kuitenkin todeta, että kotikäytössä mainetta niittänyt plug & play antaa mahdollisuuden parantaa laajentuvia markkinoita ja uusia induktiivisia tuotantomenetelmiä.",
        "Tapahtumat viime aikoina osoittavat, että useiden maanlaajuisia palveluita tarjoavien alan suuryritysten lanseeraama mobiili-internet -teknologia auttaa käyttäjää ymmärtämään meihin kohdistuvaa tietotarvetta.",
        "Ei sovi unohtaa, että vallankumouksellinen kolmannen sukupolven matkapuhelimien ja varsinkin e-business -sektorille suunnattujen laitteiden kirjo on kiteytetty aatteeseen, jossa pohditaan tahojen yhteistyön kariutumisesta aiheutuvia hyökyaaltoja rahoitus- ja sijoitussektorilla.",
        "Jotta emme unohtaisi yhteisön pyrkimyksiä, todettakoon, että useimpiin käyttötarkoituksiin aivan liian raskas relaatiotietokanta pakottaa kohderyhmää huomioimaan nykysukupolvia henkisesti rasittavaa elämäntyyliä.",
        "Tilastot osoittavat, että tietoyhteiskunta havainnollistaa hyvinvointimalliamme sekä erilaisissa laitoksissa tapahtuvaa valmistusta.",
        "On hyvin vaikea johdatella asioita siten, että verkottuva länsimaailma asettaa tahomme tukalaan tilanteeseen ajateltaessa huomaamattomia haittatekijöitä.",
        "Tosiasia on, että suurelle yleisölle vielä varsin tuntematon vaatimusmäärittely on kiteytetty aatteeseen, jossa pohditaan vastuuntuntoisten yhteistyökumppaneiden aatteellisia intressejä.",
        "Me emme tiedä mitä tapahtuu todella, jos prototyyppiasteella oleva uusi hajauttamaton ratkaisu ennakoi osaltaan hiusten halkomiseksi osoittautunutta geneerisyyttä.",
        "Jotta emme unohtaisi yhteisön pyrkimyksiä, todettakoon, että tiedon valtatie, joka tosin jossain määrin on vanhentunut käsite, opettaa sisäistämään laajentuvia markkinoita ja uusia induktiivisia tuotantomenetelmiä.",
        "Jopa riittävän tietosuojan tarjoava ratkaisu panostaa interaktiivisuuteen ajattelematta nykysukupolvia henkisesti rasittavaa elämäntyyliä.",
        "Jopa riittävän tietosuojan tarjoava ratkaisu avaa itse kullekin tiedon ja ymmärryksen portin kohti hiusten halkomiseksi osoittautunutta geneerisyyttä."
        };
        for (int i = 0; i < 10; i++)
        {
            Random r = new Random();
            int j = r.Next(lauseet.Length);
            double tulosOPISKELIJA = SanojenPituusKeskiarvo(lauseet[j]);
            double tulosMALLI = SanojenPituusKeskiarvoMalliRANDOMCHECK(lauseet[j]);

            if (Math.Abs(tulosOPISKELIJA - tulosMALLI) > 0.01)
            {
                Console.WriteLine("Ratkaisusi on: VÄÄRIN");
                Console.WriteLine("=====================");
                Console.WriteLine($"ESIMERKKILAUSE: {lauseet[j]}\n");
                string[] sanat = Paloittele(lauseet[j]);
                int kirjaimia = sanat.Sum(x => x.Length);
                int sanoja = sanat.Length;
                Console.WriteLine($"Sanoja: {sanoja}, kirjaimia: {kirjaimia}");
                Console.WriteLine($"Keskipituus pitäisi olla: {tulosMALLI:F2}");
                Console.WriteLine($"Sinun ratkaisusi antaa keskipituudeksi {tulosOPISKELIJA:F2}");
                return;
            }
        }
        Console.WriteLine("Ratkaisusi on OIKEIN");
    }


    /// <summary>
    ///  Opiskelijan ratkaisu (tämä poistetaan).
    /// </summary>
    /// <param name="v"></param>
    /// <returns></returns>
    public static double SanojenPituusKeskiarvo(string v)
    {
        throw new NotImplementedException();
    }


    /// <summary>
    /// Sanojen pituus
    /// </summary>
    /// <param name="s">Merkkijono</param>
    /// <returns></returns>
    /// <example>
    /// <pre name="test">
    /// SanojenPituusKeskiarvoMalliRANDOMCHECK("Kolme miestä istuu saunassa.") === 6;
    /// SanojenPituusKeskiarvoMalliRANDOMCHECK("Kolme miestä istuu saunassa") === 6;
    /// SanojenPituusKeskiarvoMalliRANDOMCHECK("Kolme  miestä  istuu  saunassa") === 6;
    /// SanojenPituusKeskiarvoMalliRANDOMCHECK("Kolmemiestäistuusaunassa") === 24;
    /// SanojenPituusKeskiarvoMalliRANDOMCHECK("Kolmemiestäistuusaunassa.") === 24;
    /// SanojenPituusKeskiarvoMalliRANDOMCHECK("") === 0;
    /// SanojenPituusKeskiarvoMalliRANDOMCHECK(" .,") === 0;
    /// </pre>
    /// </example>
    public static double SanojenPituusKeskiarvoMalliRANDOMCHECK(string s)
    {
        string[] jonot = Paloittele(s);
        int summa = 0;
        foreach (string jono in jonot)
        {
            summa += jono.Length;
        }
        if (jonot.Length == 0) return 0;
        return 1.0 * summa / jonot.Length;
    }

    private static string[] Paloittele(string s)
    {
        return s.Split(new char[] { ' ', '.', ',' }, StringSplitOptions.RemoveEmptyEntries);
    }

    //DELETEEND
}
