using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using static T3_SanojenPituus;

[TestFixture]
public class TestT3_SanojenPituus
{
    [Test]
    public void TestSanojenPituusKeskiarvo26()
    {
        Assert.AreEqual(6, SanojenPituusKeskiarvo("Kolme miestä istuu saunassa."), "in method SanojenPituusKeskiarvo, line 27");
        Assert.AreEqual(6, SanojenPituusKeskiarvo("Kolme miestä istuu saunassa"), "in method SanojenPituusKeskiarvo, line 28");
        Assert.AreEqual(6, SanojenPituusKeskiarvo("Kolme  miestä  istuu  saunassa"), "in method SanojenPituusKeskiarvo, line 29");
        Assert.AreEqual(24, SanojenPituusKeskiarvo("Kolmemiestäistuusaunassa"), "in method SanojenPituusKeskiarvo, line 30");
        Assert.AreEqual(24, SanojenPituusKeskiarvo("Kolmemiestäistuusaunassa."), "in method SanojenPituusKeskiarvo, line 31");
        Assert.AreEqual(0, SanojenPituusKeskiarvo(""), "in method SanojenPituusKeskiarvo, line 32");
        Assert.AreEqual(0, SanojenPituusKeskiarvo(" .,"), "in method SanojenPituusKeskiarvo, line 33");
        Assert.AreEqual(7, SanojenPituusKeskiarvo("Kolme miestä, myös Pertti, istuskeleepi lauteilla."), "in method SanojenPituusKeskiarvo, line 33");
    }
}

